using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Threading;

namespace SQLStressTool
{
    public partial class ConnSQL : Form
    {
        private Main parent;
        private string _connstring = string.Empty;

        public ConnSQL(Main parent_form)
        {
            parent = parent_form;
            InitializeComponent();
        }

        private void ConnSQL_Load(object sender, EventArgs e)
        {
            chk_Integrated.Checked = true;
            box_dbs.Enabled = false;
            btn_connect.Enabled = false;
            button1.Enabled = false;
            box_dbs.Items.Clear();
        }
        private void chk_sql_CheckedChanged(object sender, System.EventArgs e)
        {
            if (chk_sql.Checked)
            {
                txt_pwd.Enabled = true;
                txt_pwd.Text = string.Empty;
                txt_user.Enabled = true;
            }
            else
            {
                txt_pwd.Enabled = false;
                txt_pwd.Text = string.Empty;
                txt_user.Enabled = false;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _connstring = _connstring.Replace("=master;", "=" + box_dbs.SelectedItem.ToString().Trim() + ";");
            parent._SqlConnString = _connstring;
            if (txt_sqlsrv.Text.Trim().IndexOf(@"\") > 0)
            {
                parent._SqlInstance = txt_sqlsrv.Text.Trim().Substring(0, txt_sqlsrv.Text.Trim().IndexOf(@"\")).Replace("(local)", System.Environment.MachineName).Replace("localhost", System.Environment.MachineName);
            }
            else
                parent._SqlInstance = txt_sqlsrv.Text.Trim().Replace("(local)", System.Environment.MachineName).Replace("localhost", System.Environment.MachineName);
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        void txt_sqlsrv_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            if ((txt_sqlsrv.Text.Trim().Length > 0) && (chk_Integrated.Checked))
                btn_connect.Enabled = true;
            else
                btn_connect.Enabled = false;
            
        }
        void box_dbs_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (box_dbs.SelectedItem.ToString().Trim().Length > 0)
                button1.Enabled = true;
            else
                button1.Enabled = false;
        }
        void box_dbs_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
        {

            if (box_dbs.SelectedItem == null)
            {
                button1.Enabled = false;
                box_dbs.SelectedIndex = -1;
            }
            
        }


        private void btn_connect_Click(object sender, EventArgs e)
        {
            box_dbs.Items.Clear();
            _connstring = "Data Source=" + txt_sqlsrv.Text.Trim() + ";Initial Catalog=master;";
            if (chk_sql.Checked)
                _connstring += "User Id="+ txt_user.Text + ";Password="+ txt_pwd.Text + ";";
            else
                _connstring += "Integrated Security=True;";

            try
            {
                using (SqlConnection conn = new SqlConnection(_connstring))
                {
                    conn.Open();
                    using (SqlCommand comm = new SqlCommand("select name from sys.databases order by name", conn))
                    {
                        comm.CommandTimeout = 300;
                        DateTime StartTime = DateTime.Now;
                        SqlDataReader rs = comm.ExecuteReader();
                        while (rs.Read())
                        {
                            box_dbs.Items.Add(rs["name"].ToString());
                        }
                        rs.Close();
                    }
                }
                box_dbs.Enabled = true;
            }
            catch (SqlException err)
            {
                box_dbs.Items.Clear();
                MessageBox.Show(err.Message, "Connection Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

    }
}